(*   ----StartMark v1.3----
 :
 StartMark v1.3
  Delphi 5,6 ...
    

      Image.
   StartMark        Delphi.

:
Active: Boolean; -  true  Picture  
Picture: TPicture; -  
ShowTime: longint;  -     
Transparent: Boolean; -  .      
                        (  ),    TBitmap. ,
                            Bitmap    .

19.01.02 .
     tarasui@aport.ru (׸   );
*)

unit StartMark;

interface

uses
  Windows, Classes, Graphics, Forms,
  MarkForm; //

type
  TStartMark = class(TComponent)
  private
    { Private declarations }
    FShowTime: longint;
    FPicture: TPicture;
    FTransparent: Boolean;
    FActive: Boolean;
    procedure SetShowTime(Val: longint);
    procedure SetPicture(Val : TPicture);
    function  GetPicture: TPicture;
    procedure SetActive(Val: Boolean);
    procedure SetTransparent(Val: Boolean );
    function  GetTransparent: Boolean;
  protected
    { Protected declarations }
  public
    { Public declarations }
    CONSTRUCTOR Create(AOwner : TComponent); override;
    destructor  Destroy; override;
  published
    { Published declarations }
    property ShowTime: longint read FShowTime write SetShowTime;
    property Picture: TPicture read GetPicture write SetPicture;
    property Transparent: Boolean read GetTransparent write SetTransparent;
    property Active: Boolean read FActive write SetActive default False;
  end;

procedure Register;

implementation

CONSTRUCTOR TStartMark.Create(AOwner : TComponent);
begin
 FShowTime:=1000;
 FPicture:=TPicture.Create;
 INHERITED Create(AOwner);
end;

procedure Register;
begin
  RegisterComponents('Grundic', [TStartMark]);
end;

procedure TStartMark.SetPicture(Val : TPicture);
begin
if Val <> nil then
 FPicture.Assign(Val);
end;

procedure TStartMark.SetTransparent(Val: Boolean );
begin
if Val <> FTransparent then
FTransparent:= Val;
end;

function TStartMark.GetTransparent: Boolean;
begin
 Result := FTransparent;
end;

function TStartMark.GetPicture: TPicture;
begin
 Result := fPicture;
end;

procedure TStartMark.SetShowTime(Val: longint);
begin
 if Val <> ShowTime then
 FShowTime:=Val;
end;

procedure Delay(d: word); assembler;
//label  m1;
var
   FirstTick : longint;
begin
{
Application.ProcessMessages;
 asm
 mov   dx,d
 mov   ax,47
 mul   dx
 mov   cl,8
 shr   ax,cl
 shl   dx,cl
 add   ax,dx
 push  ax
 mov   ah,0
 int   1ah
 pop   ax
 add   dx,ax
 mov   bx,dx
m1:
 int   1ah
 cmp   dx,bx
 jne   m1
 end;
}
//   <ocean2000@hotbox.ru> 22.02.2006   
     FirstTick:=GetTickCount;
     repeat    
       Application.ProcessMessages; 
       {    "" Windows}
     until GetTickCount-FirstTick >= d;
end;

procedure TStartMark.SetActive(Val: Boolean);
var  M: TMark;
begin
 if not (csDesigning in componentstate) then
 begin
  if val = True then
     begin
     m:=TMark.Create(self);
     m.Brush.Style := bsClear;
     m.Logo.Picture.Assign(Picture);
     m.Height:=m.Logo.Height;
     m.Width:=m.Logo.Width;
     m.Logo.Transparent := Transparent;
     m.Visible := true;
//+ Pause
     Delay(ShowTime);
     m.Free;
     end;
 end;
FActive := Val;
end;

destructor TStartMark.Destroy;
begin
  inherited Destroy;
end;

end.
